<?php 
defined('C5_EXECUTE') or die(_("Access Denied."));

class HeartConcrete5Package extends Package {

	protected $pkgHandle = 'heart_concrete5';
	protected $appVersionRequired = '5.5.0';
	protected $pkgVersion = '1.0.4';

	public function getPackageDescription() {
		return t("Heart concrete5 theme. Using concrete5? Shout about it!");
     }

	public function getPackageName() {
		return t("Heart concrete5");
     }
 
	public function install() {
		$pkg = parent::install();

		## Install Blocks
		BlockType::installBlockTypeFromPackage('autonav', $pkg);
		BlockType::installBlockTypeFromPackage('formigo_login', $pkg);
		BlockType::installBlockTypeFromPackage('formigo_slider', $pkg);
		BlockType::installBlockTypeFromPackage('formigo_social_life', $pkg);
		BlockType::installBlockTypeFromPackage('formigo_social_links', $pkg);
		
		## Install Theme
		PageTheme::add('heart_concrete5', $pkg);
		
		## Install Page Types
		if(!is_object(CollectionType::getByHandle('heart_c5_frontpage'))) {
		$data['ctHandle'] = 'heart_c5_frontpage';
		$data['ctName'] = t('Hc5 Frontpage');
		$hpt = CollectionType::add($data, $pkg);
		}
		
		if(!is_object(CollectionType::getByHandle('heart_c5_no_picture'))) {
		$data['ctHandle'] = 'heart_c5_no_picture';
		$data['ctName'] = t('Hc5 No Picture');
		$hpt = CollectionType::add($data, $pkg);
		}
		
		if(!is_object(CollectionType::getByHandle('heart_c5_side_bar'))) {
		$data['ctHandle'] = 'heart_c5_side_bar';
		$data['ctName'] = t('Hc5 Sidebar');
		$hpt = CollectionType::add($data, $pkg);
		}
		
		if(!is_object(CollectionType::getByHandle('heart_c5_side_bar_no_picture'))) {
		$data['ctHandle'] = 'heart_c5_side_bar_no_picture';
		$data['ctName'] = t('Hc5 Sidebar No Picture');
		$hpt = CollectionType::add($data, $pkg);
		}
		
	}

	public function uninstall() {
		parent::uninstall();
	}
	
} 