<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));

class FormigoCookiesDisclosurePackage extends Package {

    protected $pkgHandle = 'formigo_cookies_disclosure';
    protected $appVersionRequired = '5.5.0';
    protected $pkgVersion = '1.0.3';

    public function getPackageDescription() {
	 
        return t("Prevents tracking script cookies being set until disclosure made and opt-in obtained.");
     
	}

    public function getPackageName() {
     
		return t("Formigo Cookies Disclosure");
     
	}
	
    public function install() {
	
		$pkg = parent::install();
		
		## Install Single Pages
	    Loader::model('single_page');
			
		## Dashboard
		$cookies = SinglePage::add('/dashboard/system/environment/cookies', $pkg);
		$cookies->update(array('cName' => 'Cookies Disclosure', 'cDescription' => 'Configure Cookie disclosure options'));
	
    }
	 
	public function uninstall() {

        $pkg = parent::uninstall();

    }

	public function on_start() {
				
	 	## Cookies Disclosure
		Events::extend('on_before_render', 'CookiesDisclosure', 'checkDiscloseCookies', 'packages/'.$this->pkgHandle.'/models/cookiesDisclosure.php');

	}		
     
}
?>