<?php     
defined('C5_EXECUTE') or die(_("Access Denied."));

class FormigoLoginBlockController extends BlockController {
	 
	protected $btTable = 'btFormigoLogin';
	protected $btInterfaceWidth = "400";
	protected $btInterfaceHeight = "180";

	public $showForm = true;
	
	public $helpers = array('form');
	
	public function getBlockTypeDescription() {
		
		return t("Add a simple-to-style login block to your website");
		
	}
	
	public function getBlockTypeName() {
		
		return t("Formigo Login");
		
	}
	
	function view(){ 
		
		## Show login form or not
		$u = new User();
		$c = $this->getCollectionObject();
		
		if ($u->isRegistered()) {
			
			$this->showForm = false;
			
		}
					
		if($c->isEditMode()) {
		
			$this->showForm =true;
			
		}	
		
		$this->set('showForm',$this->showForm);
		
		## Show Register Link
		if($this->showRegisterLink && ENABLE_REGISTRATION) {
			
			$registerLink = '<div class="register-wrapper"><a href="'.View::url('/register').'">'.t('Register').'</a></div>';
			$this->set('registerLink',$registerLink);
			
		}	
			
		## Are we redirecting back	
		$curPage = Page::getCurrentPage();
		
		if($this->returnToSamePage){ 
			
			$form = Loader::helper('form');
			$this->set('redirectLocation', $form->hidden('rcID',$curPage->getCollectionID()));
		
		} 
		
		## Login info 
		if (Config::get("ENABLE_USER_PROFILES")) {
			
			$userName = '<a href="' . $this->url('/profile') . '">' . $u->getUserName() . '</a>';
			
		} else {
			
			$userName = $u->getUserName();
			
		}
		
		$loginInfo ='<span class="sign-in">'.t('Currently logged in as <b>%s</b>: ', $userName).'<a href="'.view::url('/login', 'logout').'">'.t('Sign Out').'</a>';
		$this->set('loginInfo',$loginInfo);
			
	}
	
	function save($args) { 
		
		$args['showRegisterLink'] = isset($args['showRegisterLink']) ? 1 : 0;
		$args['returnToSamePage'] = isset($args['returnToSamePage']) ? 1 : 0;

		parent::save($args);
		
	}
	
}	
?>