<?php  defined('C5_EXECUTE') or die(_("Access Denied."));

class FormigoSocialLifeBlockController extends BlockController {

	protected $btTable = 'btFormigoSocialLife';
	protected $btInterfaceWidth = "480";
	protected $btInterfaceHeight = "320";
	protected $btWrapperClass = 'ccm-ui';
	protected $btCacheBlockOutput = true; 
	protected $btCacheBlockOutputForRegisteredUsers = false; 
	protected $btCacheBlockOutputLifetime = 300; 
	 
	public function getSearchableContent(){
		
		return $this->content;
		
	}
	
	public function getBlockTypeDescription() {	
		
		return t("Add all your social feeds to your concrete5 website");
		
	}
	
	public function getBlockTypeName() {
		
		return t("Formigo Social Life");	
		
	}
	
	public function add() {
		
		loader::library('formigoSocialLife', 'heart_concrete5');
		$sf = new formigoSocialLife();
		$services = $sf->getServices();
		$selectOptions = array();
		$apiKeyOptions = 'var apiKey = new Array();'."\n";
		$apiKeyName = 'var apiKeyName = new Array();'."\n";
		$available = 'var available = new Array();'."\n";
		$requireUri = 'var requireUri = new Array();'."\n";
		$selectOptions[''] = 'Please select..';
		
		foreach($services as $key => $value) {
			$selectOptions[$key] = $value['name'];	
			$apiKeyOptions .= 'apiKey[\''.$key.'\'] = \''.$value['requireApiKey'].'\';'."\n";
			if($value['requireApiKey'] == true) {
				$apiKeyName .= 'apiKeyName[\''.$key.'\'] = \''.$value['apiKeyName'].'\';'."\n";
			} else {
				$apiKeyName .= 'apiKeyName[\''.$key.'\'] = \'false\''."\n";
			}	
			$available .= 'available[\''.$key.'\'] = \''.$value['available'].'\';'."\n";
			$requireUri .= 'requireUri[\''.$key.'\'] = \''.$value['requireURI'].'\';'."\n";
		}
		
		$curServicesHelp = t('Select a social service to use');
		$this->set('servicesHelp', $curServicesHelp);
		$this->set('apiKeyStyle', 'display:none;');
		$this->set('rssStyle', 'display:none;');
		

		$this->set('selectOptions', $selectOptions);
		$this->set('apiKeyOptions', $apiKeyOptions);
		$this->set('apiKeyName', $apiKeyName);
		$this->set('available', $available);
		$this->set('requireUri', $requireUri);
		
	}
	
	public function edit() {
		
		loader::library('formigoSocialLife', 'heart_concrete5');
		$sf = new formigoSocialLife();
		$services = $sf->getServices();
		$selectOptions = array();
		$apiKeyOptions = 'var apiKey = new Array();'."\n";
		$apiKeyName = 'var apiKeyName = new Array();'."\n";
		$available = 'var available = new Array();'."\n";
		$requireUri = 'var requireUri = new Array();'."\n";
		$selectOptions[''] = 'Please select..';
		
		foreach($services as $key => $value) {
			$selectOptions[$key] = $value['name'];	
			$apiKeyOptions .= 'apiKey[\''.$key.'\'] = \''.$value['requireApiKey'].'\';'."\n";
			if($value['requireApiKey'] == true) {
				$apiKeyName .= 'apiKeyName[\''.$key.'\'] = \''.$value['apiKeyName'].'\';'."\n";
			} else {
				$apiKeyName .= 'apiKeyName[\''.$key.'\'] = \'false\''."\n";
			}	
			$available .= 'available[\''.$key.'\'] = \''.$value['available'].'\';'."\n";
			$requireUri .= 'requireUri[\''.$key.'\'] = \''.$value['requireURI'].'\';'."\n";
			
			## Get info about currently selected
			if($this->feed == $key) {
				$curApiKey = $value['requireApiKey'];
				$curApiKeyName = $value['apiKeyName'];
				$curAvailable = $value['available'];
				$curRequireUri = $value['requireURI'];	
			}		
		}
		
		## Set display state
		if($curApiKey == 'true') {
			$this->set('apiKeyStyle', 'display:block;');
		} else {
			$this->set('apiKeyStyle', 'display:none;');
		}
		
		if($curRequireUri == 'true') {
			$this->set('rssStyle', 'display:block;');
			$this->set('userIDStyle', 'display:none;');
		} else {
			$this->set('rssStyle', 'display:none;');
			$this->set('userIDStyle', 'display:block;');
		}
		
		$curServicesHelp = t('Display').' '. $curAvailable .' '. t('on your website'); 
		$curApiHelp = t('This service requires an') . ' ' . $curApiKeyName;
		$this->set('servicesHelp', $curServicesHelp);
		$this->set('apiHelp', $curApiHelp);
	
		if($this->feedItems == 1000) {
			$this->set('feedItems','');
		}	
		
		$this->set('selectOptions', $selectOptions);
		$this->set('apiKeyOptions', $apiKeyOptions);
		$this->set('apiKeyName', $apiKeyName);
		$this->set('available', $available);
		$this->set('requireUri', $requireUri);
		
	}		
	
	public function view() {
	
		loader::library('formigoSocialLife', 'heart_concrete5');
		$sf = new formigoSocialLife();
		
		$sf->setFeed($this->feed);
		$sf->setFeedId($this->feedID);
		
		if($this->feedItems) {
			$sf->setFeedItems($this->feedItems);
		}		
		if($this->feedApiKey) {
			$sf->setApiKey($this->feedApiKey);
		}
		if($this->feed == "rss") {
			$sf->setRSSUri($this->feedURI);
		}	
	
		$data = $sf->getFeed();
		
		if($this->feedCustomTitle) {
			$data[1]['feedIntro'] = $this->feedCustomTitle;
		}	
		$this->set('feedCustomTitle', $data[1]['feedIntro']);
		$this->set('data', $data[0]);
		$this->set('meta', $data[1]);

		if($data[0]) {
			if(!$data[0]['error']) {
				$this->render('views/'.$this->feed);
			}
		}
		
		## Or Will render default view
		
	}

	public function save($data) {
		
		if(!$data['feedItems']) {
			$data['feedItems'] = 1000;
		}
		
		$data['enableTitle'] = isset($data['enableTitle']) ? 1 : 0;
		$data['enableShadow'] = isset($data['enableShadow']) ? 1 : 0;

		parent::save($data);
		
	}		
	
	public function getJavaScriptStrings() {
      
		return array(
         	'badFeed' => t('Please select a Social Feed'),
			'badFeedId' => t('Please enter a Username or ID for the service')
		);
   	
	}
	
}