<?php  defined('C5_EXECUTE') or die(_("Access Denied."));

class formigoSocialLife {

	protected $feed;
	protected $feedId;
	protected $feedUri;
	protected $feedHomeUri;
	protected $feedIcon;
	protected $feedFormat = 'json';
	protected $feedItems = 10;
	protected $feedType;
	protected $feedIntro;
	protected $timeout = 10;
	protected $key;
	protected $strip;
	protected $options;
	
	public function setFeed($feed) {	
		$this->feed = $feed;
	}	
	
	public function setFeedId($feedId) {	
		$this->feedId = $feedId;	
	}	
	
	public function setFeedItems($feedItems) {
		$this->feedItems = $feedItems;	
	}	
	
	public function setFeedType($feedType) {		
		$this->feedType = $feedType;	
	}	
	
	public function setApiKey($key) {
		$this->key = $key;
	}	
	
	public function setRSSUri($feedUri) {
		$this->feedUri = $feedUri;
	}	
	
	public function getServices() {
		
		$services = array (
							'twitter' => array (
												'name' => t('Twitter'), 
												'available' => t('latest Tweets'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'facebook' => array ( 
												'name' => t('Facebook'), 
												'available' => t('latest Wall Posts'), 
												'requireURI' => 'false',
												'requireApiKey' => 'true',
												'apiKeyName' => t('Access Token')
												),
							'google' => array (
												'name' => t('Google+'), 
												'available' => t('latest Google+ Posts'),
												'requireURI' => 'false', 
												'requireApiKey' => 'true',
												'apiKeyName' => t('API Key')
												),	
							'instagram' => array (
												'name' => t('Instagram'), 
												'available' => t('user feed'), 
												'requireURI' => 'false',
												'requireApiKey' => 'true',
												'apiKeyName' => 'Access Token'
												),
							'delicious' => array (
												'name' => t('Delicious'), 
												'available' => t('latest Likes'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'stumbleupon' => array (
												'name' => t('Stumbleupon'), 
												'available' => t('Favourites'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),			
							'pinterest' => array (
												'name' => t('Pinterest'), 
												'available' => t('latest Pins'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'dribbble' => array (
												'name' => t('Dribbble'), 
												'available' => t('Favourites'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'youtube' => array (
												'name' => t('Youtube'), 
												'available' => t('Youtube videos'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),						
							'vimeo' => array (
												'name' => t('Vimeo'), 
												'available' => t('Vimeo videos'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'flickr' => array (
												'name' => t('Flickr'), 
												'available' => t('uploads'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),
							'lastfm' => array (
												'name' => t('Last.fm'), 
												'available' => t('recently listened to Tracks'), 
												'requireURI' => 'false',
												'requireApiKey' => 'true',
												'apiKeyName' => t('API Key')
												),
							'tumblr' => array (
												'name' => t('Tumblr'), 
												'available' => t('latest Posts'), 
												'requireURI' => 'false',
												'requireApiKey' => 'false'
												),		
							'rss' => array (
												'name' => t('RSS Feed'), 
												'available' => t('an external RSS feed'),
												'requireURI' => 'true', 
												'requireApiKey' => 'false'
												)
							);	
								
		return $services;
											
	}	
	
	public function getFeed() {

		switch ($this->feed) {
			case 'twitter':
				$this->feedUri = 'http://api.twitter.com/1/statuses/user_timeline.json?screen_name='
					. $this->feedId.'&include_entities=true&count='
					. $this->feedItems.'&callback=?';
				$this->feedHomeUri = 'http://twitter.com/'.$this->feedId;
				$this->feedIcon = 'twitter.png';
				$this->feedIntro = t("Twitter Feed");
				$this->feedFormat = 'json';
				$response = $this->feedRequest();		
			break;
			
			case 'facebook':
				$this->feedUri = 'https://graph.facebook.com/me/posts';
				$this->feedHomeUri = $this->fbLink();		
				$this->feedIcon = 'facebook.png';
				$this->feedIntro = t("Facebook Wall");
				$this->feedFormat = 'json';
				$query = array(
								'fields' => 'message,picture',
								'limit' => '100',
								'access_token' => $this->key
							);
				$dataString = $this->makeQuerystring($query);					
				$this->feedUri = $this->feedUri.'?'.$dataString;
				$response = $this->feedRequest();
			break;
			
			case 'google':
				$this->feedUri = 'https://www.googleapis.com/plus/v1/people/'
					. $this->feedId
					. '/activities/public';
				$this->feedHomeUri = 'https://plus.google.com/'.$this->feedId;
				$this->feedIcon = 'googleplus.png';
				$this->feedIntro = t("Shared on Google+");
				$this->feedFormat = 'json';
				$query = array(
								'key' => $this->key
							);
				$dataString = $this->makeQuerystring($query);					
				$this->feedUri = $this->feedUri.'?'.$dataString; 							
				$response = $this->feedRequest();
			break;
			
			case 'instagram':
				$this->feedUri = 'https://api.instagram.com/v1/users/'.$this->feedId.'/media/recent/';
				$this->feedHomeUri = null;
				$this->feedIcon = 'instagram.png';
				$this->feedIntro = t("On Instagram");
				$this->feedFormat = 'json';
				$data = array(
								'access_token' => $this->key
							);
				$dataString = $this->makeQuerystring($data);					
				$this->feedUri = $this->feedUri.'?'.$dataString;
				$response = $this->feedRequest();
			break;
			
			case 'delicious':
				$this->feedUri = 'http://feeds.delicious.com/v2/json/'.$this->feedId;
				$this->feedHomeUri = 'http://www.delicious.com/'.$this->feedId;
				$this->feedIcon = 'delicious.png';
				$this->feedIntro = t("Bookmarked");
				$this->feedFormat = 'json';	
				$response = $this->feedRequest();
			break;
			
			case 'stumbleupon':
				$this->feedUri = 'http://www.stumbleupon.com/rss/stumbler/'.$this->feedId.'/likes';
				$this->feedHomeUri = 'http://www.stumbleupon.com/stumbler/'.$this->feedId;
				$this->feedIcon = 'stumbleupon.png';
				$this->feedFormat = 'xml';
				$this->feedIntro = t("Stumbled");
				$this->strip = array('<![CDATA[', ']]>');
				$response = $this->feedRequest();
			break;
			
			case 'pinterest':
				$this->feedUri = 'http://www.pinterest.com/'
					.$this->feedId.'/feed.rss';
				$this->feedHomeUri = 'http://www.pinterest.com/'.$this->feedId;
				$this->feedIcon = 'pinterest.png';
				$this->feedIntro = t("Pinned");
				$this->feedFormat = 'xml';
				$response = $this->feedRequest();
			break;
			
			case 'dribbble':
				$this->feedUri = 'http://api.dribbble.com/players/'.$this->feedId.'/shots';
				$this->feedHomeUri = 'http://www.dribbble.com/'.$this->feedId;
				$this->feedIcon = 'dribbble.png';
				$this->feedIntro = t("Posted");
				$this->feedFormat = 'json';
				$response = $this->feedRequest();
			break;
			
			case 'youtube':
				$this->feedUri = 'https://gdata.youtube.com/feeds/api/users/'.$this->feedId.'/uploads?v=2&alt=jsonc';
				$this->feedHomeUri = 'https://www.youtube.com/user/'.$this->feedId.'/videos?flow=grid&view=0';
				$this->feedIcon = 'youtube.png';
				$this->feedIntro = t("On Youtube");
				$this->feedFormat = 'json';
				$response = $this->feedRequest();
			break;
			
			case 'vimeo':
				$this->feedUri = 'http://vimeo.com/api/v2/'.$this->feedId.'/videos.json';
				$this->feedHomeUri = 'http://www.vimeo.com/'.$this->feedId;
				$this->feedIcon = 'vimeo.png';
				$this->feedIntro = t("On Vimeo");
				$this->feedFormat = 'json';
				$response = $this->feedRequest();
			break;
			
			case 'flickr':
				$this->feedUri = 'http://api.flickr.com/services/feeds/photos_public.gne?id='
				. $this->feedId . '&lang=us-en&format=rss_200';
				$this->feedHomeUri = 'http://www.flickr.com/photos/' . $this->feedId;
				$this->feedIcon = 'flickr.png';
				$this->feedIntro = t("On Flickr");
				$this->feedFormat = 'xml';
				$response = $this->feedRequest();
			break;
			
			case 'lastfm':
				$this->feedUri = 'http://ws.audioscrobbler.com/2.0/';
				$this->feedHomeUri = 'http://www.last.fm/user/'.$this->feedId;
				$this->feedIcon = 'lastfm.png';
				$this->feedIntro = t("Now Playing");
				$this->feedFormat = 'xml';
				$query = array(
								'method' => 'user.getRecentTracks',
								'user' => $this->feedId,
								'api_key' => $this->key
							);
				
				$dataString = $this->makeQuerystring($query);					
				$this->feedUri = $this->feedUri.'?'.$dataString;
				$response = $this->feedRequest();
			break;
			
			case 'tumblr':
				$this->feedUri = 'http://'.$this->feedId.'.tumblr.com/api/read/json?callback=?';
				$this->feedHomeUri = 'http://'.$this->feedId.'.tumblr.com';
				$this->feedIcon = 'tumblr.png';
			 	$this->feedIntro = t("Tumblr Posts");
				$this->feedFormat = 'json';
				$this->strip = array('var tumblr_api_read = ', ';');
				$response = $this->feedRequest();
			break;
			
			case 'rss':
				$this->feedIntro = t("Posted");
				$this->feedFormat = 'xml';	
				$response = $this->feedRequest();
			break;
			
		}	
		
		$meta = array(
					'feedHomeUri' => $this->feedHomeUri,
					'feedIcon' => $this->feedIcon,
					'feedIntro' => $this->feedIntro,
					'feedItems' => $this->feedItems
					);
		
		$data = array($response, $meta);
		return $data;
		
	}	
	
	protected function feedRequest(){
		
		$fr = Loader::helper('file');
		$js = Loader::helper('json');

		if($this->feedFormat == 'json') {
			## JSON			
			$json = $fr->getContents($this->feedUri, $this->timeout);
			## Strip routine. Some of these json feeds aren't standard
			if($this->strip){
				foreach($this->strip as $stripTxt) {
					$json = str_replace($stripTxt,'',$json);
				}	
			}	
			$responseObject = $js->decode($json);	
			$response = $this->objectToArray($responseObject);
		} else {
			## XML
			$xml = $fr->getContents($this->feedUri, $this->timeout);
			if($this->strip){
				foreach($this->strip as $stripTxt) {
					$xml = str_replace($stripTxt,'',$xml);
				}	
			}	
			
			if(is_object(@simplexml_load_string($xml))) {
				## Makes sure we have valid XML
				$response = $this->objectToArray($js->decode($js->encode((array) simplexml_load_string($xml)),1));
			} 
		
		}	
		
		if($response) {
			return $response;
		} else {
			return false;
		}	
			
	}
	
	protected function makeQuerystring($query){
		
		foreach($query as $key=>$value) { $dataString .= $key.'='.$value.'&'; }
		$dataString = rtrim($dataString, '&');
		return $dataString;
		
	}		

	protected function objectToArray($o) {
		
		if (is_object($o)) {
			$o = get_object_vars($o);
		}

		if (is_array($o)) {
			return array_map(array('formigoSocialLife', 'objectToArray'), $o);
		} else {
			return $o;
		}
			
	}
	
	protected function fbLink() {
		
		$fr = Loader::helper('file');
		$js = Loader::helper('json');
		$uri = 'https://graph.facebook.com/'. $this->feedId;
		$json = $fr->getContents($uri, $this->timeout);
		$responseObject = $js->decode($json);	
		$response = $this->objectToArray($responseObject);
		return $response['link'];
		
	}	
}	